%% Generacin Burst
close all; clear, clc

f=40e3;                     % frecuencia de trabajo
t_captura=1e-3;             % Tiempo mximo de captura
T=1/f;                      % Periodo
N_ciclos=5;                 % Numero de ciclos de la seal de emisin 
fs=10e6;                    % Frecuencia de muestreo de la seal
ts=1/fs;                    % Perodo de muestreo

duracion_ciclos=N_ciclos*T;         
t=0:ts:t_captura;           % Variable de tiempo
N=length(t);                % Numero de muestras
ciclos=duracion_ciclos/ts;  % Generacin del seno
x=sin(2*pi*f*t(1:ciclos));  % Rellenado por ceros
x(ciclos+1:N)=0;            % Seal senoidal modulada por Burst

figure,plot(t,x)
title(['Seal senoidal de ' num2str( f ) 'kHz modulada por un Burst'])
xlabel('tiempo (s)'), ylabel('amplitud (adim)')

%% Funcion gausiana

y=(0:1:ciclos-1);
gauss=gaussmf(y,[ciclos/5 ciclos/2]);

figure,plot(gauss),axis([0 length(gauss) 0 1])
title('Funcion gausiana moduladora del burst')

gauss(ciclos:N)=0;
x=x.*gauss;

figure,plot(t,x)
title('Seal de emisin'),xlabel('tiempo (s)'), ylabel('amplitud (adim)')

%% Dominio frecuencial

frec=(-fs/2:fs/(N-1):fs/2);   %Vector con el eje de frecuencias
X=abs(fftshift(fft(x,N))/N);
figure,subplot(2,1,1),plot(frec,X)
title('Seal de emisin - dominio frecuencial'), xlabel('frecuencia Hz')
subplot(2,1,2),plot(frec,X),axis([0 80e3 min(min(X)) max(max(X))])
title('Seal de emisin - dominio frecuencial'), xlabel('frecuencia Hz')

x=x';
x=x(1:end-1);

save(['Burst_gauissiano_seno' num2str((f/1000)) 'kHz_' num2str(t_captura,'%.e') 's_' num2str(N_ciclos) 'ciclos' '.txt'],'x','-ascii')