    %% Variables iniciales, Cargado y filtrado de la seal
nombre_fichero='madera_2_3canales.txt'; % Nombre de fichero
dist=0.0244; % distancia entre transductores
condicion_inferior=xx; % Condicin infrerior de la velocidad de propagacin para el ajuste de la correlacin
condicion_superior=xx; % Condicin superior de la velocidad de propagacin para el ajuste de la correlacin
    
[s1,s2,s3,tiempo,s1_f,s2_f,s3_f]=representacion_prototipo(nombre_fichero,4000); % Cargado, representacin y filtrado de las seales

    %% Clculo de la correlacin 

corr1=(xcorr(s1,s2)); % Clculo de la correlacin para el sensor 1
corr2=(xcorr(s1,s3)); % Clculo de la correlacin para el sensor 2
    
M1=max(corr1);
M2=max(corr2);
max_corr_1=find(corr1==M1); % clculo de la posicin del valor mximo de correlacin para el sensor 1
max_corr_2=find(corr2==M2); % clculo de la posicin del valor mximo de correlacin para el sensor 2
    
N=length(corr1);
corr1(N/2:end)=0;
corr2(N/2:end)=0;
          
figure,set(gcf,'Color',[1 1 1]),plot(-1:2/length(corr1):1-(2/length(corr1)),corr1,'r'),hold on,plot(-1:2/length(corr2):1-(2/length(corr2)),corr2)
title('correlacin entre emisin y recepcin'),legend('correlacin sensor 1', 'correlacin sensor 2')
    
y=(0:1:length(corr1)-1);
    
    %% Clculo del tiempo de vuelo y velocidad de propagacin
    
desplazamiento1=(N/2)-max_corr_1; % Clculo del desplazamiento de la seal del sensor 1
desplazamiento2=(N/2)-max_corr_2; % Clculo del desplazamiento de la seal del sensor 2
    
t1=desplazamiento1*tiempo(1); % Clculo del tiempo de vuelo para el sensor 1
t2=desplazamiento2*tiempo(1); % Clculo del tiempo de vuelo para el sensor 3
v1= dist/t1; % Clculo de la velocidad de propagacin para el sensor 1
v2= dist/t2; % Clculo de la velocidad de propagacin para el sensor 2
    
    
while v1<condicion_inferior || v1> condicion_superior % condicin para el ajuste de las seales
        
    corr1(max_corr_1-2:max_corr_1+2)=0;
    M1=max(corr1);
    max_corr_1=find(corr1==M1);
    desplazamiento1=(N/2)-max_corr_1;
    t1=desplazamiento1*tiempo(1);
    v1= dist/t1;
    
end
    
while v2<condicion_inferior || v2>condicion_superior % condicin para el ajuste de las seales
    
    corr2(max_corr_2-2:max_corr_2+2)=0;
    M2=max(corr2);
    max_corr_2=find(corr2==M2);
    desplazamiento2=(N/2)-max_corr_2;
    t2=desplazamiento2*tiempo(1);
    v2= dist/t2;
    
end
    
display(['La velocidad de propagacin para el transductor 1 ha sido ' num2str(v1) ]);
display(['La velocidad de propagacin para el transductor 1 ha sido ' num2str(v2) ]);
    
  %% Representacin del ajuste de las correlaciones
  
desplazamiento1=ceil(desplazamiento1);s11=zeros(length(s1)+desplazamiento1,1);
s11(desplazamiento1+1:end,1)=s1_f;figure,set(gcf,'Color',[1 1 1]),
subplot(2,1,1),plot(s11,'r'), hold on,plot(s2_f),xlim([0 N/2])
title('Ajuste tras la correlacin - Seal 1'),xlabel('Muestras'),ylabel('Amplitud normalizada')
desplazamiento2=ceil(desplazamiento2);s22=zeros(length(s2)+desplazamiento2,1);
s22(desplazamiento2+1:end,1)=s1_f;subplot(2,1,2),plot(s22,'r'), hold on,plot(s3_f),xlim([0 N/2])
title('Ajuste tras la correlacin - Seal 2'),xlabel('Muestras'),ylabel('Amplitud normalizada')

