function [Senal1,Senal2,Senal3,tiempo,Senal1_f,Senal2_f,Senal3_f] = representacion_prototipo(nombre_fichero,att)
% Representacin y filtrado de las seales captadas por los sensores
% ultrasnicos
% Los parmetros de entrada son los siguientes:
    % Nombre del fichero que contiene los datos de cada uno de los canales de la seal
    % att, atenuacin de la seal de excitacin para la representacin

%% Cargado de seal

senal=load(nombre_fichero);

tiempo=senal(:,1);
Senal1=senal(:,2);
Senal2=senal(:,3);
Senal3=senal(:,4);

N=length(tiempo);
inc_temp=abs(tiempo(1))-abs(tiempo(2));
tiempo=(1:N)*inc_temp;
tiempo=tiempo';


%% Representacin de las seales

figure,set(gcf,'Color',[1 1 1])
subplot(3,1,1),plot(tiempo,Senal1,'r'),title('Seal de emisin'),xlim([0 3e-4])
xlabel('Tiempo (s)'),ylabel('Amplitud (V)') 
subplot(3,1,2),plot(tiempo,Senal2,'b'),title('Receptor 1'),xlim([0 3e-4])
xlabel('Tiempo (s)'),ylabel('Amplitud (V)') 
subplot(3,1,3),plot(tiempo,Senal3,'k'),title('Receptor 2'),xlim([0 3e-4])
xlabel('Tiempo (s)'),ylabel('Amplitud (V)') 

%% Hi-pas

 b1=fir1(80,0.03,'high');
 Senal2_f1=filtfilt(b1,1,Senal2);
 Senal3_f1=filtfilt(b1,1,Senal3);

%% Filtro mediana elimina continua
 
 med1=mean(Senal2_f1);
 Senal2_f1=Senal2_f1-med1;
 med2=mean(Senal3_f1);
 Senal3_f1=Senal3_f1-med2;

%% Low-pass

 b1=fir1(80,0.015);
 Senal1_f=filtfilt(b1,1,Senal1);
 Senal2_f=filtfilt(b1,1,Senal2_f1);
 Senal3_f=filtfilt(b1,1,Senal3_f1);
 
%% Representacin seales filtradas

figure,set(gcf,'Color',[1 1 1])
plot(tiempo,Senal2_f,'b'),xlim([0 3e-4]),xlabel('Tiempo (s)'),ylabel('Amplitud (V)')
hold on
plot(tiempo,Senal3_f,'k'),title('Seales de recepcin'),xlabel('Tiempo (s)'),ylabel('Amplitud (V)')
legend('Receptor 1','Receptor 2')

Senal1_f=Senal1_f/att;
figure,set(gcf,'Color',[1 1 1])
subplot(3,1,1),plot(tiempo,Senal1_f,'r'),title('Seal de emisin'),xlim([0 4e-4])
xlabel('Tiempo (s)'),ylabel('Amplitud (V)') 
subplot(3,1,2),plot(tiempo,Senal2_f,'b'),title('Receptor 1'),xlim([0 3e-4])
xlabel('Tiempo (s)'),ylabel('Amplitud (V)') 
subplot(3,1,3),plot(tiempo,Senal3_f,'k'),title('Receptor 2'),xlim([0 3e-4])
xlabel('Tiempo (s)'),ylabel('Amplitud (V)') 

end



